unit Edit1;

interface

uses
  System.SysUtils, System.Classes, Vcl.Controls, Vcl.StdCtrls, Messages,
  Graphics;

type
  TEdit1ExMy = class(TEdit)
  private
    { Private-Deklarationen }
    FErrorColor: TColor;
    FTestInput: Boolean;
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Message: TWMSetFocus); message WM_KILLFOCUS;

    function CheckRVNR(inputText: string): Boolean;

  protected
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;

  published
    { Published-Deklarationen }
    property ErrorColor: TColor read FErrorColor write FErrorColor
      default clRed;
    property TestInput: Boolean read FTestInput write FTestInput default false;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('MeineKomponenten', [TEdit1ExMy]);
end;

{ TEdit1ExMy }

constructor TEdit1ExMy.Create(AOwner: TComponent);
begin
  inherited;
  FErrorColor := clRed;
  FTestInput := false;
end;

procedure TEdit1ExMy.WMSetFocus(var Message: TWMSetFocus);
begin
  inherited;
  Self.Color := clWindow;
end;

procedure TEdit1ExMy.WMKillFocus(var Message: TWMSetFocus);
var
  inputText: string;
begin
  inherited;
  inputText := Self.Text;
  if FTestInput = true then
  begin
    if CheckRVNR(inputText) = false then
    begin
      Self.Color := FErrorColor;
    end;
  end;
end;

function TEdit1ExMy.CheckRVNR(inputText: string): Boolean;
var
  pruefZifferInput: integer;
  pruefZiffer: integer;
  quersumme: integer;
  values: array [0 .. 11] of integer;
  value9_10: integer;
  value9_10_AsString: string;
  produkte: array [0 .. 11] of integer;
  i: integer;
  z: string;
const
  gewichtung: Array [0 .. 11] of integer = (2, 1, 2, 5, 7, 1, 2, 1, 2, 1, 2, 1);
begin
  if inputText.Length <> 12 then
    exit;
  z := inputText[12];
  pruefZifferInput := z.ToInteger();

  // Stellen 1-8 (Region + Geburtsdatum)
  for i := 0 to 7 do
  begin
    z := inputText[i + 1];
    values[i] := z.ToInteger();
    produkte[i] := values[i] * gewichtung[i];
  end;

  // Buchstabe Stelle 9 (Geburtsname)
  value9_10 := ord(inputText[9]) - 64;
  if value9_10 < 10 then
    value9_10_AsString := '0' + value9_10.ToString
  else
    value9_10_AsString := value9_10.ToString;

  z := value9_10_AsString[1];
  values[8] := z.ToInteger();
  produkte[8] := values[8] * gewichtung[8];

  z := value9_10_AsString[2];
  values[9] := z.ToInteger();
  produkte[9] := values[9] * gewichtung[9];

  // Stellen 10-11 (Ordnungsnummer)
  for i := 9 to 10 do
  begin
    z := inputText[i + 1];
    values[i + 1] := z.ToInteger();
    produkte[i + 1] := values[i + 1] * gewichtung[i + 1];
  end;

  // Quersumme der Produkte
  quersumme := 0;

  for i := 0 to 11 do
  begin
    quersumme := quersumme + 1 + ((produkte[i] - 1) mod 9);
  end;

  // Prfziffer
  pruefZiffer := quersumme mod 10;

  if pruefZifferInput = pruefZiffer then
    result := true
  else
    result := false;
end;

end.
